//+------------------------------------------------------------------+
//|                                                  afTester-01.mq5 |
//|                        Copyright 2011, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"

#include <MyExperts\MarketDriver_02.mqh>

#define IndCount 8
enum eShape
  {
   shSinus,  // ""
   shMeandr, // ""
   shTrender,// ""
   shDJoker,  // "D-"
   shJoker,  // ""
   shJokerF1,  // "-F1"
  };

//--- input parameters
input double   x0=1;
input double   x1=1;
input double   x2=1;
input double   x3=1;
input double   x4=1;
input double   x5=1;
input double   x6=1;
input double   x7=1;
input int      HistoryLen=5;
input double   Agression=0;
input int      IndPeriod=9;
input eShape       Shape=shSinus;       //   
input double       kF1=1.0;             //  F1
input double       TrenderLevel = 1.4;  //   
input double       TrenderTrigger=0.7;  //   
input double       TrenderMult =  4;    //   
input int      NormPeriod=28800;
input double   LotSize=15.0;
input double   PerMult=1.5;
input double   TLMult=1.1;
input double   TTMult=1.1;
input double   LotMult=1.1;

CMarketDriver   MD;               //  
SymbolPos       Position[1];      //  
int             hInd[IndCount];             //  
double          perMul=1;
double          tlMul=1;
double          ttMul=1;
double          X[IndCount];
double          CNorm=1;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   for(int i=0;i<IndCount;i++)
     {
      hInd[i]=iCustom(NULL,0, "MyCustom\afTrailShort_04",
        NormPeriod,HistoryLen*perMul,Agression,Shape,kF1,TrenderLevel*tlMul,TrenderTrigger*ttMul,TrenderMult,IndPeriod*perMul);
      Sleep(int(50*perMul));  //Sleep(100);
      perMul*=PerMult;
      tlMul*=TLMult;
      ttMul*=TTMult;
     }
   CNorm = MathSqrt(x0*x0+x1*x1+x2*x2+x3*x3+x4*x4+x5*x5+x6*x6+x7*x7);
   X[0]=x0/CNorm;   X[1]=x1/CNorm;   X[2]=x2/CNorm;   X[3]=x3/CNorm;
   X[4]=x4/CNorm;   X[5]=x5/CNorm;   X[6]=x6/CNorm;   X[7]=x7/CNorm;
   
   Position[0].Sym=Symbol();
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   int Err;
   Position[0].Pos=GetLot()*LotSize;
   MD.Synhronize(Position,Err);

  }
//+------------------------------------------------------------------+
double GetLot()
  {
   double L[1];
   double lot=0;
   double lotMul=1;
   for(int i=0;i<IndCount;i++)
     {
       CopyBuffer(hInd[i],0,0,1,L); 
       lot+=10*L[0]*X[i];                            
       //(MathLog(lotMul*IndPeriod));
//       lotMul*=LotMult;
     }


   return lot;
  }
//+------------------------------------------------------------------+
